
BIOS_NAME		:= bios
BIOS_SRC		:= $(PATH_SRC)/$(BIOS_NAME)
BIOS_BIN		:= $(PATH_BIN)/$(BIOS_NAME)
BIOS_HEX		:= $(BIOS_BIN)/$(BIOS_NAME).hex
BIOS_DAT		:= $(BIOS_BIN)/$(BIOS_NAME).dat
BIOS_RELS		:= $(BIOS_BIN)/$(BIOS_NAME).rel
BIOS_CODE		:= $(BIOS_SRC)/$(BIOS_NAME).asm
BUILD_HELP		+= \\n\\t* $(BIOS_DAT)

$(BIOS_BIN):
	$(call mb_mkdir,$(BIOS_BIN))

$(BIOS_BIN)/%.rel: $(BIOS_SRC)/%.asm | $(BIOS_BIN)
	$(call mb_compile_asm,$@,$<)

$(BIOS_HEX): $(BIOS_RELS)
	$(call mb_link_asm_dos,$(BIOS_HEX),$(BIOS_RELS))

$(BIOS_DAT): $(BIOS_HEX)
	$(call mb_hex2dat,$(BIOS_HEX),$(BIOS_DAT))
