
DOME_NAME		:= dome
DOME_SRC		:= $(PATH_SRC)/$(DOME_NAME)
DOME_BIN		:= $(PATH_BIN)/$(DOME_NAME)
DOME_HEX		:= $(DOME_BIN)/$(DOME_NAME).hex
DOME_DAT		:= $(DOME_BIN)/$(DOME_NAME).dat
DOME_RELS		:= $(DOME_BIN)/$(DOME_NAME).rel
DOME_CODE		:= $(DOME_SRC)/$(DOME_NAME).asm
BUILD_HELP		+= \\n\\t* $(DOME_DAT)

# TODO fix build trigger on ai_new.asm

$(DOME_BIN):
	$(call mb_mkdir,$(DOME_BIN))

$(DOME_BIN)/%.rel: $(DOME_SRC)/%.asm | $(DOME_BIN)
	$(call mb_compile_asm,$@,$<)

$(DOME_HEX): $(DOME_RELS)
	$(call mb_link_asm_8000,$(DOME_HEX),$(DOME_RELS))

$(DOME_DAT): $(DOME_HEX)
	$(call mb_hex2dat,$(DOME_HEX),$(DOME_DAT))
