
LEVELS_NAME		:= levels
LEVELS_SRC		:= $(PATH_SRC)/$(LEVELS_NAME)
LEVELS_BIN		:= $(PATH_BIN)/$(LEVELS_NAME)
BUILD_HELP		+= \\n\\t* $(LEVELS_BIN)/code.001 / $(LEVELS_BIN)/code.002

$(LEVELS_BIN):
	$(call mb_mkdir,$(LEVELS_BIN))
	$(call mb_copy,$(LEVELS_SRC)/*.00*,$(LEVELS_BIN))
#cp $(LEVELS_SRC)/*.00* $(LEVELS_BIN);

$(LEVELS_BIN)/code001.rel: $(LEVELS_SRC)/code001.asm | $(LEVELS_BIN)
	$(call mb_compile_asm,$@,$<)
	
$(LEVELS_BIN)/code002.rel: $(LEVELS_SRC)/code001.asm | $(LEVELS_BIN)
	$(call mb_compile_asm,$@,$<)

$(LEVELS_BIN)/code001.hex: $(LEVELS_BIN)/code001.rel
	$(call mb_link_asm_1000,$@,$<)
	
$(LEVELS_BIN)/code002.hex: $(LEVELS_BIN)/code002.rel
	$(call mb_link_asm_1000,$@,$<)
	
$(LEVELS_BIN)/code001.dat: $(LEVELS_BIN)/code001.hex
	$(call mb_hex2dat,$<,$@)
	
$(LEVELS_BIN)/code002.dat: $(LEVELS_BIN)/code002.hex
	$(call mb_hex2dat,$<,$@)
	
$(LEVELS_BIN)/code.001: $(LEVELS_BIN)/code001.dat
	$(call mb_copy,$<,$@)
	
$(LEVELS_BIN)/code.002: $(LEVELS_BIN)/code002.dat
	$(call mb_copy,$<,$@)
