
MENU_NAME		:= menu
MENU_SRC		:= $(PATH_SRC)/$(MENU_NAME)
MENU_BIN		:= $(PATH_BIN)/$(MENU_NAME)
MENU_HEX		:= $(MENU_BIN)/$(MENU_NAME).hex
MENU_DAT		:= $(MENU_BIN)/$(MENU_NAME).dat
MENU_RELS		:= $(MENU_BIN)/$(MENU_NAME).rel
MENU_CODE		:= $(MENU_SRC)/$(MENU_NAME).asm
BUILD_HELP		+= \\n\\t* $(MENU_DAT)

$(MENU_BIN):
	$(call mb_mkdir,$(MENU_BIN))

$(MENU_BIN)/%.rel: $(MENU_SRC)/%.asm | $(MENU_BIN)
	$(call mb_compile_asm,$@,$<)

$(MENU_HEX): $(MENU_RELS)
	$(call mb_link_asm_8000,$(MENU_HEX),$(MENU_RELS))

$(MENU_DAT): $(MENU_HEX)
	$(call mb_hex2dat,$(MENU_HEX),$(MENU_DAT))
