
DIST_RUN_NAME		:= dist-run
DIST_RUN_BIN		:= $(PATH_BIN)/$(DIST_RUN_NAME)
DIST_RUN_SRC		:= $(PATH_SRC)/$(DIST_RUN_NAME)
DIST_RUN_INC		:= init.com dome.000
DIST_RUN_INC_BIN 	:= $(patsubst %,$(DIST_RUN_BIN)/%,$(DIST_RUN_INC))
BUILD_HELP			+= \\n\\t* $(DIST_RUN_NAME)

$(DIST_RUN_BIN):
	$(call mb_mkdir,$(DIST_RUN_BIN))

$(DIST_RUN_BIN)/init.com: bin/init/init.com | $(DIST_RUN_BIN)
	cp $< $@;
$(DIST_RUN_BIN)/dome.000: bin/domelib/dome.000 | $(DIST_RUN_BIN)
	cp $< $@;
	cp bin/domelib/*.zop $(DIST_RUN_BIN);
	cp bin/domelib/*.dat $(DIST_RUN_BIN);
	cp bin/domelib/*.00* $(DIST_RUN_BIN);
	echo "=== Overwrite org zop gfx until working..."
	cp src/gfx/org/*.zop $(DIST_RUN_BIN);

$(DIST_RUN_NAME): $(DIST_RUN_INC_BIN)
	$(call mb_autoexec_open_gui_cmd,$(DIST_RUN_BIN),init)
	$(call mb_openmsx_dos2,$(DIST_RUN_BIN))
