
GFX_NAME		:= gfx
GFX_SRC			:= $(PATH_SRC)/$(GFX_NAME)
GFX_BIN			:= $(PATH_BIN)/$(GFX_NAME)
GFX_SRC_FILES	:= $(call rwildcard, $(PATH_SRC)/$(GFX_NAME), *.ge5)
GFX_BIN_FILES 	:= $(patsubst $(PATH_SRC)/$(GFX_NAME)/%.ge5,$(GFX_BIN)/%.zop,$(GFX_SRC_FILES))
BUILD_HELP		+= \\n\\t* gfx / test-gfx

# TODO: add unittot.ge5
#
#10 SCREEN 5 : SETPAGE 1,1
#20 BLOAD"units.ge5",S : COLOR=RESTORE
#30 SETPAGE 2,2
#40 BLOAD"2row.ge5",S
#50 SETPAGE 1,1
#60 COPY (0,0)-(256,32),2 TO (0,208),1
#70 BSAVE"unit.pop",&H8000,&HFFFF,S
#80 _SYSTEM("pop.bat")
#

$(GFX_BIN):
	$(call mb_mkdir,$(GFX_BIN))

$(GFX_BIN)/popcom.com: $(GFX_BIN)
	$(call mb_msxhub_file,$(GFX_BIN)/popcom.com,https://msxhub.com/api/POPCOM/1.00-1/get/POPCOM/popcom.com)
	
$(GFX_BIN)/%.zop: $(GFX_SRC)/%.ge5 | $(GFX_BIN) $(GFX_BIN)/popcom.com
	cp $< $(GFX_BIN)
	$(call mb_autoexec_write_default,$(GFX_BIN))
	$(call mb_autoexec_append_cmd,$(GFX_BIN),omsxctl fail_after 60 seconds fail_basic_script 126 > NUL)
	#add-gui-debug; $(call mb_autoexec_append_cmd,$(GFX_BIN),omsxctl set renderer SDL > NUL)
	$(call mb_autoexec_append_echo,$(GFX_BIN),Running basic conversion step)
	$(call mb_autoexec_append_cmd,$(GFX_BIN),basic conv.bas)
	
	@echo "10 SCREEN 5 : SETPAGE 1,1\r" > $(GFX_BIN)/conv.bas;
	@echo "20 BLOAD\"$(notdir $<)\",S : COLOR=RESTORE\r" >> $(GFX_BIN)/conv.bas;
	@echo "30 BSAVE\"$(notdir $@)\",&H0000,&H7FFF,S\r" >> $(GFX_BIN)/conv.bas;
	@echo "40 _SYSTEM(\"pop.bat\")\r" >> $(GFX_BIN)/conv.bas;
	
	@echo "\r" > $(GFX_BIN)/pop.bat;
	@echo "mode 80 > NUL\r" >> $(GFX_BIN)/pop.bat;
	@echo "omsxctl fail_after 120 seconds fail_popcom 126 > NUL\r" >> $(GFX_BIN)/pop.bat;
	@echo "popcom $(notdir $@)\r" >> $(GFX_BIN)/pop.bat;
	@echo "echo \"All done..................\"\r" >> $(GFX_BIN)/pop.bat;
	@echo "omsxctl exit\r" >> $(GFX_BIN)/pop.bat;
	
	$(call mb_openmsx_dos2, $(GFX_BIN))

test-gfx: gfx
	$(call mb_autoexec_open_gui,$(GFX_BIN))
	$(call mb_autoexec_append_echo,$(GFX_BIN),Selecting 7Mhz speed.)
	$(call mb_autoexec_append_cmd,$(GFX_BIN),omsxctl set speed 200 > NUL)
	$(call mb_openmsx_dos2,$(GFX_BIN))

gfx: $(GFX_BIN_FILES)
	echo All GFX are compressed.
