
INIT_NAME		:= init
INIT_SRC		:= $(PATH_SRC)/$(INIT_NAME)
INIT_BIN		:= $(PATH_BIN)/$(INIT_NAME)
INIT_HEX		:= $(INIT_BIN)/$(INIT_NAME).hex
INIT_COM		:= $(INIT_BIN)/$(INIT_NAME).com
INIT_RELS		:= $(INIT_BIN)/$(INIT_NAME).rel
INIT_CODE		:= $(INIT_SRC)/$(INIT_NAME).asm
BUILD_HELP		+= \\n\\t* $(INIT_COM)

$(INIT_BIN):
	$(call mb_mkdir,$(INIT_BIN))

$(INIT_BIN)/%.rel: $(INIT_SRC)/%.asm | $(INIT_BIN)
	$(call mb_compile_asm,$@,$<)

$(INIT_HEX): $(INIT_RELS)
	$(call mb_link_asm_dos,$(INIT_HEX),$(INIT_RELS))

$(INIT_COM): $(INIT_HEX)
	$(call mb_hex2com,$(INIT_HEX),$(INIT_COM))
