
LOADER_NAME		:= loader
LOADER_SRC		:= $(PATH_SRC)/$(LOADER_NAME)
LOADER_BIN		:= $(PATH_BIN)/$(LOADER_NAME)
LOADER_HEX		:= $(LOADER_BIN)/$(LOADER_NAME).hex
LOADER_DAT		:= $(LOADER_BIN)/$(LOADER_NAME).dat
LOADER_RELS		:= $(LOADER_BIN)/$(LOADER_NAME).rel
LOADER_CODE		:= $(LOADER_SRC)/$(LOADER_NAME).asm
BUILD_HELP		+= \\n\\t* $(LOADER_DAT)

$(LOADER_BIN):
	$(call mb_mkdir,$(LOADER_BIN))

$(LOADER_BIN)/%.rel: $(LOADER_SRC)/%.asm | $(LOADER_BIN)
	$(call mb_compile_asm,$@,$<)

$(LOADER_HEX): $(LOADER_RELS)
	$(call mb_link_asm_8000,$(LOADER_HEX),$(LOADER_RELS))

$(LOADER_DAT): $(LOADER_HEX)
	$(call mb_hex2dat,$(LOADER_HEX),$(LOADER_DAT))
