
MAKELIB_NAME	:= makelib
MAKELIB_SRC		:= $(PATH_SRC)/$(MAKELIB_NAME)
MAKELIB_BIN		:= $(PATH_BIN)/$(MAKELIB_NAME)
MAKELIB_HEX		:= $(MAKELIB_BIN)/$(MAKELIB_NAME).hex
MAKELIB_COM		:= $(MAKELIB_BIN)/$(MAKELIB_NAME).com
MAKELIB_RELS	:= $(MAKELIB_BIN)/$(MAKELIB_NAME).rel
MAKELIB_CODE	:= $(MAKELIB_SRC)/$(MAKELIB_NAME).asm
BUILD_HELP		+= \\n\\t* $(MAKELIB_COM)

$(MAKELIB_BIN):
	$(call mb_mkdir,$(MAKELIB_BIN))

$(MAKELIB_BIN)/%.rel: $(MAKELIB_SRC)/%.asm | $(MAKELIB_BIN)
	$(call mb_compile_asm,$@,$<)

$(MAKELIB_HEX): $(MAKELIB_RELS)
	$(call mb_link_asm_dos,$(MAKELIB_HEX),$(MAKELIB_RELS))

$(MAKELIB_COM): $(MAKELIB_HEX)
	$(call mb_hex2com,$(MAKELIB_HEX),$(MAKELIB_COM))
