
MMENU_NAME		:= mmenu
MMENU_SRC		:= $(PATH_SRC)/$(MMENU_NAME)
MMENU_BIN		:= $(PATH_BIN)/$(MMENU_NAME)
MMENU_HEX		:= $(MMENU_BIN)/$(MMENU_NAME).hex
MMENU_DAT		:= $(MMENU_BIN)/$(MMENU_NAME).dat
MMENU_RELS		:= $(MMENU_BIN)/$(MMENU_NAME).rel
MMENU_CODE		:= $(MMENU_SRC)/$(MMENU_NAME).asm
BUILD_HELP		+= \\n\\t* $(MMENU_DAT)

$(MMENU_BIN):
	$(call mb_mkdir,$(MMENU_BIN))

$(MMENU_BIN)/%.rel: $(MMENU_SRC)/%.asm | $(MMENU_BIN)
	$(call mb_compile_asm,$@,$<)

$(MMENU_HEX): $(MMENU_RELS)
	$(call mb_link_asm_4000,$(MMENU_HEX),$(MMENU_RELS))

$(MMENU_DAT): $(MMENU_HEX)
	$(call mb_hex2dat,$(MMENU_HEX),$(MMENU_DAT))
